"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getMetadata = getMetadata;
exports.getParserOpts = getParserOpts;
exports.locatePluginOpts = locatePluginOpts;

var _babylonLightscript = require("@oigroup/babylon-lightscript");

var parser = _interopRequireWildcard(_babylonLightscript);

var _package = require("../package.json");

var _package2 = _interopRequireDefault(_package);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

// TODO: generalize this
function getMetadata() {
  return {
    parser,
    getParserOpts,
    name: _package2.default.name,
    version: _package2.default.version,
    fqn: _package2.default.name + "@" + _package2.default.version,
    features: {
      "bangCall": {}
    }
  };
}

function getParserOpts(pluginOpts, initialParserOpts) {
  var parserOpts = initialParserOpts || {};
  parserOpts.parser = parser.parse;

  parserOpts.plugins = parserOpts.plugins || [];
  var plugins = parserOpts.plugins;

  plugins.unshift("lightscript");
  // TODO: allow configuration options to disable these, as they slow down parsing
  plugins.push("jsx", "flow", "objectRestSpread");
  plugins.push("safeCallExpression", "existentialExpression");

  if ((pluginOpts == null ? null : pluginOpts.features) == null ? null : pluginOpts.features.bangCall) plugins.push("bangCall");

  return parserOpts;
} // Attempt to determine whether a post-processed Babel plugin is this
// plugin. This is necessary because Babel doesn't specify the individual
// plugin configuration during manipulateOptions, only the global configuration.
// But we need the local plugin config there to enable parser flags.
// EXTREMELY hackish.


function isMe(entry, thisPlugin) {
  return entry.manipulateOptions === thisPlugin.manipulateOptions;
}

function locatePluginOpts(opts, thisPlugin) {
  var plugins = opts == null ? null : opts.plugins;
  if (!plugins) return {};

  for (var _i2 = 0, _len2 = plugins.length; _i2 < _len2; _i2++) {
    var _plugin = plugins[_i2];

    if (Array.isArray(_plugin)) {
      if (isMe(_plugin[0], thisPlugin)) return _plugin[1];
    } else {
      if (isMe(_plugin, thisPlugin)) return {};
    }
  }

  return {};
}